#include <iostream>
#include <functional>
#include <vector>
#include <iterator>
#include <string>
#include <algorithm>
#include <numeric>

using namespace std;

int main(){

  cout << "quares: ";

  vector<int> vec{1,2,3,4,5,6,7,8,9};

  transform(vec.begin(), vec.end(),
	    vec.begin(),
	    [](int i){return i*i;});

 copy(vec.begin(), vec.end(),ostream_iterator<int>(cout, " "));

  cout << "\nSum: "
       << accumulate(vec.begin(), vec.end(), 1, multiplies<int>())
       << endl;
  
  auto it = remove_if(vec.begin(), vec.end(),
		      [](int i){return (i < 10);});

  cout << "\nfiltered: ";

  copy(vec.begin(), it,ostream_iterator<int>(cout, " "));

  cout << "\nlengths: ";

  vector<string> str{"Programming", "in", "a", "functional", "style"};
  vector<int> lengths;
  transform(str.begin(), str.end(),
  	    back_inserter(lengths),
  	    [](string s){return s.length();});
  copy(lengths.begin(), lengths.end(),ostream_iterator<int>(cout, " "));

  auto itstr = remove_if(str.begin(), str.end(),
  			 [](string s){return !(isupper(s[0]));});
  cout << "\nfiltered: ";
  copy(str.begin(), itstr,ostream_iterator<string>(cout, " "));

  cout << endl;
  
}
